ByteArrayOutputStream (Axis API)
Keywords: org.apache.axis.utils.ByteArrayOutputStream class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.axis.utils
Class ByteArrayOutputStream

    java.lang.Object
      java.io.OutputStream
          org.apache.axis.utils.ByteArrayOutputStream

public class ByteArrayOutputStream
extends java.io.OutputStream

This class implements an output stream in which the data is written into a byte array. The buffer automatically grows as data is written to it.

The data can be retrieved using `toByteArray()` and `toString()`.

Closing a `ByteArrayOutputStream` has no effect. The methods in this class can be called after the stream has been closed without generating an `IOException`.

This is an alternative implementation of the java.io.ByteArrayOutputStream class. The original implementation only allocates 32 bytes at the beginning. As this class is designed for heavy duty it starts at 1024 bytes. In contrast to the original it doesn't reallocate the whole memory block but allocates additional buffers. This way no buffers need to be garbage collected and the contents don't have to be copied to the new buffer. This class is designed to behave exactly like the original. The only exception is the deprecated toString(int) method that has been ignored.

Author:
  Jeremias Maerki

Constructor Summary
`ByteArrayOutputStream()` Creates a new byte array output stream.
`ByteArrayOutputStream(int size)` Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.

Method Summary
`void` | `close()` Closing a `ByteArrayOutputStream` has no effect.
`void` | `reset()`
`int` | `size()`
`byte[]` | `toByteArray()`
`java.lang.String` | `toString()`
`java.lang.String` | `toString(java.lang.String enc)`
`void` | `write(byte[] b, int off, int len)`
`void` | `write(int b)` Calls the write(byte[]) method.
`void` | `writeTo(java.io.OutputStream out)`

Methods inherited from class java.io.OutputStream
`flush, write`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ByteArrayOutputStream

    public ByteArrayOutputStream()

  Creates a new byte array output stream. The buffer capacity is initially 1024 bytes, though its size increases if necessary.

### ByteArrayOutputStream

    public ByteArrayOutputStream(int size)

  Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.

Parameters:
  `size` - the initial size.
Throws:
  `java.lang.IllegalArgumentException` - if size is negative.

Method Detail

### write

    public void write(byte[] b,
                      int off,
                      int len)

  See Also:
    `OutputStream.write(byte[], int, int)`

### write

    public void write(int b)

  Calls the write(byte[]) method.

  See Also:
    `OutputStream.write(int)`

### size

    public int size()

  See Also:
    `ByteArrayOutputStream.size()`

### close

    public void close()
               throws java.io.IOException

  Closing a `ByteArrayOutputStream` has no effect. The methods in this class can be called after the stream has been closed without generating an `IOException`.

  Throws:
    `java.io.IOException` - in case an I/O error occurs

### reset

    public void reset()

  See Also:
    `ByteArrayOutputStream.reset()`

### writeTo

    public void writeTo(java.io.OutputStream out)
                 throws java.io.IOException

  Throws:
    `java.io.IOException`
  See Also:
    `ByteArrayOutputStream.writeTo(OutputStream)`

### toByteArray

    public byte[] toByteArray()

  See Also:
    `ByteArrayOutputStream.toByteArray()`

### toString

    public java.lang.String toString()

  See Also:
    `ByteArrayOutputStream.toString()`

### toString

    public java.lang.String toString(java.lang.String enc)
                              throws java.io.UnsupportedEncodingException

  Throws:
    `java.io.UnsupportedEncodingException`
  See Also:
    `ByteArrayOutputStream.toString(String)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005 Apache Web Services Project. All Rights Reserved.